/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package vezerles;

import alaposztalyok.KekSzal;
import alaposztalyok.PirosSzal;
import alaposztalyok.Potty;
import alaposztalyok.Szal;
import alaposztalyok.ZoldSzal;
import feluletek.RajzPanel;
import java.awt.Graphics;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 *
 * @author :)
 */
public class Vezerlo {
    
    private List<Potty> pottyok = new ArrayList<>();
    
    private List<Szal> szalak = new CopyOnWriteArrayList<>();
    
    private ExecutorService executorService=Executors.newSingleThreadExecutor();
    
    private RajzPanel rajzPanel;
    
    private final int POTTY_SUGAR = 10;
    private final int SUGAR = 5;
    private final double LEPES = 2;
    private final long IDO = 10;

    public Vezerlo(RajzPanel rajzPanel) {
        this.rajzPanel = rajzPanel;
    }
    
    public void rajzolas(Graphics g) {
        for (Potty potty : pottyok) {
            potty.rajzol(g);
        }

        for (Szal szal : szalak) {
            szal.rajzolas(g);
        }
    }

    public void vegrehajtas(int x, int y) {
        Potty potty = new Potty(x, y, POTTY_SUGAR);   
        pottyok.add(potty);
        if(pottyok.size()>=2){
            int kx = pottyok.get(pottyok.size()-2).getKx();
            int ky = pottyok.get(pottyok.size()-2).getKy();
            int vx = pottyok.get(pottyok.size()-1).getKx();
            int vy = pottyok.get(pottyok.size()-1).getKy(); 
            
            int r = SUGAR;
            double lepes = LEPES;
            long ido = IDO;
            
            PirosSzal pirosSzal = new PirosSzal(kx, ky, vx, vy, r, lepes, ido, this);
            KekSzal kekSzal = new KekSzal(kx, ky, vx, vy, r, lepes, ido, this);
            ZoldSzal zoldSzal = new ZoldSzal(kx, ky, vx, vy, r, lepes, ido, this);
            szalak.add(pirosSzal);
            szalak.add(kekSzal);
            szalak.add(zoldSzal);
            
            //     pirosSzal.start();
            //     kekSzal.start();
            //     zoldSzal.start();
            
            executorService.execute(kekSzal);
            executorService.submit(pirosSzal);
            executorService.execute(zoldSzal);
                    }
    }

    public void frissit() {
        rajzPanel.repaint();
    }
}
